class keyboardPackage.Keyboard extends AsBroadcaster
{
   var screenKeyboards;
   var pressedKeys;
   var disabledKeys;
   var onKeyUp;
   var onKeyDown;
   static var myInstance;
   static var keyCode = new Array();
   static var keyCodeName = new Array();
   function Keyboard()
   {
      super();
      Key.addListener(this);
      this.screenKeyboards = new Array();
      this.pressedKeys = new Array();
      this.disabledKeys = new Array();
      this.setCodeTable();
      this.onKeyUp = this.onKeyUp_withoutScreenKeyboard;
      this.onKeyDown = this.onKeyDown_withoutScreenKeyboard;
      AsBroadcaster.initialize(this);
   }
   function getKeyCode(str)
   {
      str = str.toUpperCase();
      if(Key[str] != undefined)
      {
         return Key[str];
      }
      if(keyboardPackage.Keyboard.keyCode[str] != undefined)
      {
         return keyboardPackage.Keyboard.keyCode[str];
      }
      return str.charCodeAt(0);
   }
   function getKeyName(code)
   {
      if(keyboardPackage.Keyboard.keyCodeName[code] != undefined)
      {
         return keyboardPackage.Keyboard.keyCodeName[code];
      }
      return undefined;
   }
   function excludeKey(key, keybMC)
   {
      if(keybMC != undefined)
      {
         if(this.screenKeyboards[String(keybMC)] != undefined)
         {
            this.screenKeyboards[String(keybMC)].disableKey(key);
         }
      }
      else if(this.screenKeyboards.length > 0)
      {
         for(var name in this.screenKeyboards)
         {
            this.screenKeyboards[name].disableKey(key);
         }
      }
      this.disabledKeys[key] = true;
   }
   function sendEvent(keyevent, pressed)
   {
      this.broadcastMessage(keyevent,pressed);
   }
   function isAnyKeyPressed()
   {
      for(var code in this.pressedKeys)
      {
         if(this.pressedKeys[code])
         {
            return true;
         }
      }
      return false;
   }
   function onKeyDown_withoutScreenKeyboard()
   {
      var pressedkey = Key.getCode();
      this.pressedKeys[pressedkey] = true;
      this.onKeyUp();
      this.sendEvent("onKeyDown",pressedkey);
   }
   function onKeyUp_withoutScreenKeyboard()
   {
      var pressedkey = Key.getCode();
      var isDown = Key.isDown;
      for(pressedkey in this.pressedKeys)
      {
         if(!isDown(pressedkey))
         {
            delete this.pressedKeys[pressedkey];
            this.sendEvent("onKeyUp",pressedkey);
         }
      }
   }
   function onKeyDown_withScreenKeyboard(pressedkey)
   {
      var internal = false;
      if(pressedkey == undefined)
      {
         pressedkey = Key.getCode();
      }
      else
      {
         internal = true;
      }
      this.pressedKeys[pressedkey] = true;
      for(pressedkey in this.pressedKeys)
      {
         if(this.pressedKeys[pressedkey])
         {
            for(var name in this.screenKeyboards)
            {
               this.screenKeyboards[name].onPress(pressedkey);
            }
         }
      }
      if(!internal)
      {
         this.onKeyUp();
      }
      else
      {
         this.sendEvent("onScreenKeyDown",pressedkey);
      }
      this.sendEvent("onKeyDown",pressedkey);
   }
   function onKeyUp_withScreenKeyboard(pressedkey)
   {
      var pressedkey = pressedkey != undefined ? pressedkey : Key.getCode();
      var isDown = Key.isDown;
      for(pressedkey in this.pressedKeys)
      {
         if(!isDown(pressedkey))
         {
            for(var name in this.screenKeyboards)
            {
               this.screenKeyboards[name].onRelease(pressedkey);
            }
            delete this.pressedKeys[pressedkey];
            this.sendEvent("onKeyUp",pressedkey);
         }
      }
   }
   function addScreenKeyboard(keybMC)
   {
      this.screenKeyboards[String(keybMC)] = new keyboardPackage.ScreenKeyboard(keybMC);
      this.onKeyDown = this.onKeyDown_withScreenKeyboard;
      this.onKeyUp = this.onKeyUp_withScreenKeyboard;
   }
   function removeScreenKeyboard(_MC)
   {
      delete this.screenKeyboards[String(_MC)];
      if(this.screenKeyboards.length == 0)
      {
         this.onKeyUp = this.onKeyUp_withoutScreenKeyboard;
         this.onKeyDown = this.onKeyDown_withoutScreenKeyboard;
      }
   }
   function setCodeTable()
   {
      keyboardPackage.Keyboard.keyCode = new Array();
      keyboardPackage.Keyboard.keyCode.ESC = keyboardPackage.Keyboard.keyCode.ESCAPE = 27;
      keyboardPackage.Keyboard.keyCode.F1 = 112;
      keyboardPackage.Keyboard.keyCode.F2 = 113;
      keyboardPackage.Keyboard.keyCode.F3 = 114;
      keyboardPackage.Keyboard.keyCode.F4 = 115;
      keyboardPackage.Keyboard.keyCode.F5 = 116;
      keyboardPackage.Keyboard.keyCode.F6 = 117;
      keyboardPackage.Keyboard.keyCode.F7 = 118;
      keyboardPackage.Keyboard.keyCode.F8 = 119;
      keyboardPackage.Keyboard.keyCode.F9 = 120;
      keyboardPackage.Keyboard.keyCode.F10 = 120;
      keyboardPackage.Keyboard.keyCode.F11 = 122;
      keyboardPackage.Keyboard.keyCode.F12 = 123;
      keyboardPackage.Keyboard.keyCode.CAPSLOCK = keyboardPackage.Keyboard.keyCode["CAPS LOCK"] = keyboardPackage.Keyboard.keyCode.CAPS_LOCK = 20;
      keyboardPackage.Keyboard.keyCode.NUMLOCK = keyboardPackage.Keyboard.keyCode["NUM LOCK"] = keyboardPackage.Keyboard.keyCode.NUM_LOCK = 144;
      keyboardPackage.Keyboard.keyCode.SCROLLLOCK = keyboardPackage.Keyboard.keyCode["SCROLL LOCK"] = keyboardPackage.Keyboard.keyCode.SCROLL_LOCK = 145;
      keyboardPackage.Keyboard.keyCode.TAB = 9;
      keyboardPackage.Keyboard.keyCode.ALT = keyboardPackage.Keyboard.keyCode["RIGHT ALT"] = keyboardPackage.Keyboard.keyCode.RIGHT_ALT = 18;
      keyboardPackage.Keyboard.keyCode.CONTROL = keyboardPackage.Keyboard.keyCode.CTRL = 17;
      keyboardPackage.Keyboard.keyCode.SHIFT = keyboardPackage.Keyboard.keyCode.SFT = 16;
      keyboardPackage.Keyboard.keyCode.BACKSPACE = keyboardPackage.Keyboard.keyCode["BACK SPACE"] = keyboardPackage.Keyboard.keyCode.BACK_SPACE = 8;
      keyboardPackage.Keyboard.keyCode.BCKSPC = keyboardPackage.Keyboard.keyCode.BSPACE = 8;
      keyboardPackage.Keyboard.keyCode.ENTER = keyboardPackage.Keyboard.keyCode.RETURN = 13;
      keyboardPackage.Keyboard.keyCode.SPACE = keyboardPackage.Keyboard.keyCode.SPC = 32;
      keyboardPackage.Keyboard.keyCode.PAUSE = keyboardPackage.Keyboard.keyCode.BREAK = 19;
      keyboardPackage.Keyboard.keyCode["`"] = keyboardPackage.Keyboard.keyCode["~"] = keyboardPackage.Keyboard.keyCode.TILDE = 192;
      keyboardPackage.Keyboard.keyCode["1"] = 49;
      keyboardPackage.Keyboard.keyCode["2"] = 50;
      keyboardPackage.Keyboard.keyCode["3"] = 51;
      keyboardPackage.Keyboard.keyCode["4"] = 52;
      keyboardPackage.Keyboard.keyCode["5"] = 53;
      keyboardPackage.Keyboard.keyCode["6"] = 54;
      keyboardPackage.Keyboard.keyCode["7"] = 55;
      keyboardPackage.Keyboard.keyCode["8"] = 56;
      keyboardPackage.Keyboard.keyCode["9"] = 57;
      keyboardPackage.Keyboard.keyCode["0"] = 48;
      keyboardPackage.Keyboard.keyCode["-"] = keyboardPackage.Keyboard.keyCode._ = keyboardPackage.Keyboard.keyCode.MINUS = 189;
      keyboardPackage.Keyboard.keyCode["="] = keyboardPackage.Keyboard.keyCode["+"] = keyboardPackage.Keyboard.keyCode.PLUS = 187;
      keyboardPackage.Keyboard.keyCode.Q = 81;
      keyboardPackage.Keyboard.keyCode.W = 87;
      keyboardPackage.Keyboard.keyCode.E = 69;
      keyboardPackage.Keyboard.keyCode.R = 82;
      keyboardPackage.Keyboard.keyCode.T = 84;
      keyboardPackage.Keyboard.keyCode.Y = 89;
      keyboardPackage.Keyboard.keyCode.U = 85;
      keyboardPackage.Keyboard.keyCode.I = 73;
      keyboardPackage.Keyboard.keyCode.O = 79;
      keyboardPackage.Keyboard.keyCode.P = 80;
      keyboardPackage.Keyboard.keyCode.A = 65;
      keyboardPackage.Keyboard.keyCode.S = 83;
      keyboardPackage.Keyboard.keyCode.D = 68;
      keyboardPackage.Keyboard.keyCode.F = 70;
      keyboardPackage.Keyboard.keyCode.G = 71;
      keyboardPackage.Keyboard.keyCode.H = 72;
      keyboardPackage.Keyboard.keyCode.J = 74;
      keyboardPackage.Keyboard.keyCode.K = 75;
      keyboardPackage.Keyboard.keyCode.L = 76;
      keyboardPackage.Keyboard.keyCode.Z = 90;
      keyboardPackage.Keyboard.keyCode.X = 88;
      keyboardPackage.Keyboard.keyCode.C = 67;
      keyboardPackage.Keyboard.keyCode.V = 86;
      keyboardPackage.Keyboard.keyCode.B = 66;
      keyboardPackage.Keyboard.keyCode.N = 78;
      keyboardPackage.Keyboard.keyCode.M = 77;
      keyboardPackage.Keyboard.keyCode["["] = keyboardPackage.Keyboard.keyCode["{"] = 219;
      keyboardPackage.Keyboard.keyCode["]"] = keyboardPackage.Keyboard.keyCode["}"] = 221;
      keyboardPackage.Keyboard.keyCode["\\"] = keyboardPackage.Keyboard.keyCode["|"] = keyboardPackage.Keyboard.keyCode.PIPE = keyboardPackage.Keyboard.keyCode.BACKSLASH = keyboardPackage.Keyboard.keyCode.BACKSLASH = 220;
      keyboardPackage.Keyboard.keyCode[";"] = keyboardPackage.Keyboard.keyCode[":"] = 186;
      keyboardPackage.Keyboard.keyCode["\'"] = keyboardPackage.Keyboard.keyCode["\""] = 222;
      keyboardPackage.Keyboard.keyCode[","] = keyboardPackage.Keyboard.keyCode["<"] = keyboardPackage.Keyboard.keyCode.COMMA = 188;
      keyboardPackage.Keyboard.keyCode["."] = keyboardPackage.Keyboard.keyCode[">"] = keyboardPackage.Keyboard.keyCode.DOT = 190;
      keyboardPackage.Keyboard.keyCode["/"] = keyboardPackage.Keyboard.keyCode["?"] = keyboardPackage.Keyboard.keyCode.SLASH = 191;
      keyboardPackage.Keyboard.keyCode.MOUSEMENU = keyboardPackage.Keyboard.keyCode["RMB MENU"] = keyboardPackage.Keyboard.keyCode.RMBMENU = 93;
      keyboardPackage.Keyboard.keyCode.INSERT = keyboardPackage.Keyboard.keyCode.INS = 45;
      keyboardPackage.Keyboard.keyCode.DELETE = keyboardPackage.Keyboard.keyCode.DEL = keyboardPackage.Keyboard.keyCode.DELETEKEY = 46;
      keyboardPackage.Keyboard.keyCode.HOME = 36;
      keyboardPackage.Keyboard.keyCode.END = 35;
      keyboardPackage.Keyboard.keyCode["PAGE UP"] = keyboardPackage.Keyboard.keyCode.PAGE_UP = keyboardPackage.Keyboard.keyCode.PAGEUP = keyboardPackage.Keyboard.keyCode.PGUP = 33;
      keyboardPackage.Keyboard.keyCode["PAGE DOWN"] = keyboardPackage.Keyboard.keyCode.PAGE_DOWN = keyboardPackage.Keyboard.keyCode.PAGEDOWN = 34;
      keyboardPackage.Keyboard.keyCode["PAGE DN"] = keyboardPackage.Keyboard.keyCode.PAGE_DN = keyboardPackage.Keyboard.keyCode.PAGEDN = keyboardPackage.Keyboard.keyCode.PGDN = 34;
      keyboardPackage.Keyboard.keyCode["LEFT ARROW"] = keyboardPackage.Keyboard.keyCode.LEFT_ARROW = keyboardPackage.Keyboard.keyCode.LEFTARROW = 37;
      keyboardPackage.Keyboard.keyCode["RIGHT ARROW"] = keyboardPackage.Keyboard.keyCode.RIGHT_ARROW = keyboardPackage.Keyboard.keyCode.RIGHTARROW = 39;
      keyboardPackage.Keyboard.keyCode["UP ARROW"] = keyboardPackage.Keyboard.keyCode.UP_ARROW = keyboardPackage.Keyboard.keyCode.UPARROW = 38;
      keyboardPackage.Keyboard.keyCode["DOWN ARROW"] = keyboardPackage.Keyboard.keyCode.DOWN_ARROW = keyboardPackage.Keyboard.keyCode.DOWNARROW = 40;
      keyboardPackage.Keyboard.keyCode["DN ARROW"] = keyboardPackage.Keyboard.keyCode.DN_ARROW = keyboardPackage.Keyboard.keyCode.DNARROW = 40;
      keyboardPackage.Keyboard.keyCode["NUMERIC SLASH"] = keyboardPackage.Keyboard.keyCode.NUMERICSLASH = keyboardPackage.Keyboard.keyCode["NUMERIC-SLASH"] = keyboardPackage.Keyboard.keyCode.NUMERIC_SLASH = 111;
      keyboardPackage.Keyboard.keyCode["NUMKEY SLASH"] = keyboardPackage.Keyboard.keyCode.NUMKEYSLASH = keyboardPackage.Keyboard.keyCode["NUMKEY-SLASH"] = keyboardPackage.Keyboard.keyCode.NUMKEY_SLASH = 111;
      keyboardPackage.Keyboard.keyCode["NUM SLASH"] = keyboardPackage.Keyboard.keyCode.NUMSLASH = keyboardPackage.Keyboard.keyCode["NUM-SLASH"] = keyboardPackage.Keyboard.keyCode.NUM_SLASH = 111;
      keyboardPackage.Keyboard.keyCode["NUMERIC ASTERIX"] = keyboardPackage.Keyboard.keyCode.NUMERICASTERIX = keyboardPackage.Keyboard.keyCode["NUMERIC-ASTERIX"] = keyboardPackage.Keyboard.keyCode.NUMERIC_ASTERIX = 106;
      keyboardPackage.Keyboard.keyCode["NUMKEY ASTERIX"] = keyboardPackage.Keyboard.keyCode.NUMKEYASTERIX = keyboardPackage.Keyboard.keyCode["NUMKEY-ASTERIX"] = keyboardPackage.Keyboard.keyCode.NUMKEY_ASTERIX = 106;
      keyboardPackage.Keyboard.keyCode["NUM ASTERIX"] = keyboardPackage.Keyboard.keyCode.NUMASTERIX = keyboardPackage.Keyboard.keyCode["NUM-ASTERIX"] = keyboardPackage.Keyboard.keyCode.NUM_ASTERIX = 106;
      keyboardPackage.Keyboard.keyCode["NUMERIC MINUS"] = keyboardPackage.Keyboard.keyCode.NUMERICMINUS = keyboardPackage.Keyboard.keyCode["NUMERIC-MINUS"] = keyboardPackage.Keyboard.keyCode.NUMERIC_MINUS = 109;
      keyboardPackage.Keyboard.keyCode["NUMKEY MINUS"] = keyboardPackage.Keyboard.keyCode.NUMKEYMINUS = keyboardPackage.Keyboard.keyCode["NUMKEY-MINUS"] = keyboardPackage.Keyboard.keyCode.NUMKEY_MINUS = 109;
      keyboardPackage.Keyboard.keyCode["NUM MINUS"] = keyboardPackage.Keyboard.keyCode.NUMMINUS = keyboardPackage.Keyboard.keyCode["NUM-MINUS"] = keyboardPackage.Keyboard.keyCode.NUM_MINUS = 109;
      keyboardPackage.Keyboard.keyCode["NUMERIC PLUS"] = keyboardPackage.Keyboard.keyCode.NUMERICPLUS = keyboardPackage.Keyboard.keyCode["NUMERIC-PLUS"] = keyboardPackage.Keyboard.keyCode.NUMERIC_PLUS = 107;
      keyboardPackage.Keyboard.keyCode["NUMKEY PLUS"] = keyboardPackage.Keyboard.keyCode.NUMKEYPLUS = keyboardPackage.Keyboard.keyCode["NUMKEY-PLUS"] = keyboardPackage.Keyboard.keyCode.NUMKEY_PLUS = 107;
      keyboardPackage.Keyboard.keyCode["NUM PLUS"] = keyboardPackage.Keyboard.keyCode.NUMPLUS = keyboardPackage.Keyboard.keyCode["NUM-PLUS"] = keyboardPackage.Keyboard.keyCode.NUM_PLUS = 107;
      keyboardPackage.Keyboard.keyCode["NUMERIC DOT"] = keyboardPackage.Keyboard.keyCode.NUMERICDOT = keyboardPackage.Keyboard.keyCode["NUMERIC-DOT"] = keyboardPackage.Keyboard.keyCode.NUMERIC_DOT = 110;
      keyboardPackage.Keyboard.keyCode["NUMKEY DOT"] = keyboardPackage.Keyboard.keyCode.NUMKEYDOT = keyboardPackage.Keyboard.keyCode["NUMKEY-DOT"] = keyboardPackage.Keyboard.keyCode.NUMKEY_DOT = 110;
      keyboardPackage.Keyboard.keyCode["NUM DOT"] = keyboardPackage.Keyboard.keyCode.NUMDOT = keyboardPackage.Keyboard.keyCode["NUM-DOT"] = keyboardPackage.Keyboard.keyCode.NUM_DOT = 110;
      keyboardPackage.Keyboard.keyCode["NUM/"] = keyboardPackage.Keyboard.keyCode["NUM /"] = keyboardPackage.Keyboard.keyCode["NUM-/"] = keyboardPackage.Keyboard.keyCode["NUM_/"] = 111;
      keyboardPackage.Keyboard.keyCode["NUM*"] = keyboardPackage.Keyboard.keyCode["NUM *"] = keyboardPackage.Keyboard.keyCode["NUM-*"] = keyboardPackage.Keyboard.keyCode["NUM_*"] = 106;
      keyboardPackage.Keyboard.keyCode["NUM-"] = keyboardPackage.Keyboard.keyCode["NUM -"] = keyboardPackage.Keyboard.keyCode["NUM--"] = keyboardPackage.Keyboard.keyCode["NUM_-"] = 109;
      keyboardPackage.Keyboard.keyCode.NUM7 = keyboardPackage.Keyboard.keyCode["NUM 7"] = keyboardPackage.Keyboard.keyCode["NUM-7"] = keyboardPackage.Keyboard.keyCode.NUM_7 = 103;
      keyboardPackage.Keyboard.keyCode.NUM8 = keyboardPackage.Keyboard.keyCode["NUM 8"] = keyboardPackage.Keyboard.keyCode["NUM-8"] = keyboardPackage.Keyboard.keyCode.NUM_8 = 104;
      keyboardPackage.Keyboard.keyCode.NUM9 = keyboardPackage.Keyboard.keyCode["NUM 9"] = keyboardPackage.Keyboard.keyCode["NUM-9"] = keyboardPackage.Keyboard.keyCode.NUM_9 = 105;
      keyboardPackage.Keyboard.keyCode["NUM+"] = keyboardPackage.Keyboard.keyCode["NUM +"] = keyboardPackage.Keyboard.keyCode["NUM-+"] = keyboardPackage.Keyboard.keyCode["NUM_+"] = 107;
      keyboardPackage.Keyboard.keyCode.NUM4 = keyboardPackage.Keyboard.keyCode["NUM 4"] = keyboardPackage.Keyboard.keyCode["NUM-4"] = keyboardPackage.Keyboard.keyCode.NUM_4 = 100;
      keyboardPackage.Keyboard.keyCode.NUM5 = keyboardPackage.Keyboard.keyCode["NUM 5"] = keyboardPackage.Keyboard.keyCode["NUM-5"] = keyboardPackage.Keyboard.keyCode.NUM_5 = 101;
      keyboardPackage.Keyboard.keyCode.NUM6 = keyboardPackage.Keyboard.keyCode["NUM 6"] = keyboardPackage.Keyboard.keyCode["NUM-6"] = keyboardPackage.Keyboard.keyCode.NUM_6 = 102;
      keyboardPackage.Keyboard.keyCode.NUM1 = keyboardPackage.Keyboard.keyCode["NUM 1"] = keyboardPackage.Keyboard.keyCode["NUM-1"] = keyboardPackage.Keyboard.keyCode.NUM_1 = 97;
      keyboardPackage.Keyboard.keyCode.NUM2 = keyboardPackage.Keyboard.keyCode["NUM 2"] = keyboardPackage.Keyboard.keyCode["NUM-2"] = keyboardPackage.Keyboard.keyCode.NUM_2 = 98;
      keyboardPackage.Keyboard.keyCode.NUM3 = keyboardPackage.Keyboard.keyCode["NUM 3"] = keyboardPackage.Keyboard.keyCode["NUM-3"] = keyboardPackage.Keyboard.keyCode.NUM_3 = 99;
      keyboardPackage.Keyboard.keyCode.NUM0 = keyboardPackage.Keyboard.keyCode["NUM 0"] = keyboardPackage.Keyboard.keyCode["NUM-0"] = keyboardPackage.Keyboard.keyCode.NUM_0 = 96;
      keyboardPackage.Keyboard.keyCode["NUM."] = keyboardPackage.Keyboard.keyCode["NUM ."] = keyboardPackage.Keyboard.keyCode["NUM-."] = keyboardPackage.Keyboard.keyCode["NUM_."] = 110;
      keyboardPackage.Keyboard.keyCode["NUMERIC/"] = keyboardPackage.Keyboard.keyCode["NUMERIC /"] = keyboardPackage.Keyboard.keyCode["NUMERIC-/"] = keyboardPackage.Keyboard.keyCode["NUMERIC_/"] = 111;
      keyboardPackage.Keyboard.keyCode["NUMERIC*"] = keyboardPackage.Keyboard.keyCode["NUMERIC *"] = keyboardPackage.Keyboard.keyCode["NUMERIC-*"] = keyboardPackage.Keyboard.keyCode["NUMERIC_*"] = 106;
      keyboardPackage.Keyboard.keyCode["NUMERIC-"] = keyboardPackage.Keyboard.keyCode["NUMERIC -"] = keyboardPackage.Keyboard.keyCode["NUMERIC--"] = keyboardPackage.Keyboard.keyCode["NUMERIC_-"] = 109;
      keyboardPackage.Keyboard.keyCode.NUMERIC7 = keyboardPackage.Keyboard.keyCode["NUMERIC 7"] = keyboardPackage.Keyboard.keyCode["NUMERIC-7"] = keyboardPackage.Keyboard.keyCode.NUMERIC_7 = 103;
      keyboardPackage.Keyboard.keyCode.NUMERIC8 = keyboardPackage.Keyboard.keyCode["NUMERIC 8"] = keyboardPackage.Keyboard.keyCode["NUMERIC-8"] = keyboardPackage.Keyboard.keyCode.NUMERIC_8 = 104;
      keyboardPackage.Keyboard.keyCode.NUMERIC9 = keyboardPackage.Keyboard.keyCode["NUMERIC 9"] = keyboardPackage.Keyboard.keyCode["NUMERIC-9"] = keyboardPackage.Keyboard.keyCode.NUMERIC_9 = 105;
      keyboardPackage.Keyboard.keyCode["NUMERIC+"] = keyboardPackage.Keyboard.keyCode["NUMERIC +"] = keyboardPackage.Keyboard.keyCode["NUMERIC-+"] = keyboardPackage.Keyboard.keyCode["NUMERIC_+"] = 107;
      keyboardPackage.Keyboard.keyCode.NUMERIC4 = keyboardPackage.Keyboard.keyCode["NUMERIC 4"] = keyboardPackage.Keyboard.keyCode["NUMERIC-4"] = keyboardPackage.Keyboard.keyCode.NUMERIC_4 = 100;
      keyboardPackage.Keyboard.keyCode.NUMERIC5 = keyboardPackage.Keyboard.keyCode["NUMERIC 5"] = keyboardPackage.Keyboard.keyCode["NUMERIC-5"] = keyboardPackage.Keyboard.keyCode.NUMERIC_5 = 101;
      keyboardPackage.Keyboard.keyCode.NUMERIC6 = keyboardPackage.Keyboard.keyCode["NUMERIC 6"] = keyboardPackage.Keyboard.keyCode["NUMERIC-6"] = keyboardPackage.Keyboard.keyCode.NUMERIC_6 = 102;
      keyboardPackage.Keyboard.keyCode.NUMERIC1 = keyboardPackage.Keyboard.keyCode["NUMERIC 1"] = keyboardPackage.Keyboard.keyCode["NUMERIC-1"] = keyboardPackage.Keyboard.keyCode.NUMERIC_1 = 97;
      keyboardPackage.Keyboard.keyCode.NUMERIC2 = keyboardPackage.Keyboard.keyCode["NUMERIC 2"] = keyboardPackage.Keyboard.keyCode["NUMERIC-2"] = keyboardPackage.Keyboard.keyCode.NUMERIC_2 = 98;
      keyboardPackage.Keyboard.keyCode.NUMERIC3 = keyboardPackage.Keyboard.keyCode["NUMERIC 3"] = keyboardPackage.Keyboard.keyCode["NUMERIC-3"] = keyboardPackage.Keyboard.keyCode.NUMERIC_3 = 99;
      keyboardPackage.Keyboard.keyCode.NUMERIC0 = keyboardPackage.Keyboard.keyCode["NUMERIC 0"] = keyboardPackage.Keyboard.keyCode["NUMERIC-0"] = keyboardPackage.Keyboard.keyCode.NUMERIC_0 = 96;
      keyboardPackage.Keyboard.keyCode["NUMERIC."] = keyboardPackage.Keyboard.keyCode["NUMERIC ."] = keyboardPackage.Keyboard.keyCode["NUMERIC-."] = keyboardPackage.Keyboard.keyCode["NUMERIC_."] = 110;
      keyboardPackage.Keyboard.keyCode["NUMKEY/"] = keyboardPackage.Keyboard.keyCode["NUMKEY /"] = keyboardPackage.Keyboard.keyCode["NUMKEY-/"] = keyboardPackage.Keyboard.keyCode["NUMKEY_/"] = 111;
      keyboardPackage.Keyboard.keyCode["NUMKEY*"] = keyboardPackage.Keyboard.keyCode["NUMKEY *"] = keyboardPackage.Keyboard.keyCode["NUMKEY-*"] = keyboardPackage.Keyboard.keyCode["NUMKEY_*"] = 106;
      keyboardPackage.Keyboard.keyCode["NUMKEY-"] = keyboardPackage.Keyboard.keyCode["NUMKEY -"] = keyboardPackage.Keyboard.keyCode["NUMKEY--"] = keyboardPackage.Keyboard.keyCode["NUMKEY_-"] = 109;
      keyboardPackage.Keyboard.keyCode.NUMKEY7 = keyboardPackage.Keyboard.keyCode["NUMKEY 7"] = keyboardPackage.Keyboard.keyCode["NUMKEY-7"] = keyboardPackage.Keyboard.keyCode.NUMKEY_7 = 103;
      keyboardPackage.Keyboard.keyCode.NUMKEY8 = keyboardPackage.Keyboard.keyCode["NUMKEY 8"] = keyboardPackage.Keyboard.keyCode["NUMKEY-8"] = keyboardPackage.Keyboard.keyCode.NUMKEY_8 = 104;
      keyboardPackage.Keyboard.keyCode.NUMKEY9 = keyboardPackage.Keyboard.keyCode["NUMKEY 9"] = keyboardPackage.Keyboard.keyCode["NUMKEY-9"] = keyboardPackage.Keyboard.keyCode.NUMKEY_9 = 105;
      keyboardPackage.Keyboard.keyCode["NUMKEY+"] = keyboardPackage.Keyboard.keyCode["NUMKEY +"] = keyboardPackage.Keyboard.keyCode["NUMKEY-+"] = keyboardPackage.Keyboard.keyCode["NUMKEY_+"] = 107;
      keyboardPackage.Keyboard.keyCode.NUMKEY4 = keyboardPackage.Keyboard.keyCode["NUMKEY 4"] = keyboardPackage.Keyboard.keyCode["NUMKEY-4"] = keyboardPackage.Keyboard.keyCode.NUMKEY_4 = 100;
      keyboardPackage.Keyboard.keyCode.NUMKEY5 = keyboardPackage.Keyboard.keyCode["NUMKEY 5"] = keyboardPackage.Keyboard.keyCode["NUMKEY-5"] = keyboardPackage.Keyboard.keyCode.NUMKEY_5 = 101;
      keyboardPackage.Keyboard.keyCode.NUMKEY6 = keyboardPackage.Keyboard.keyCode["NUMKEY 6"] = keyboardPackage.Keyboard.keyCode["NUMKEY-6"] = keyboardPackage.Keyboard.keyCode.NUMKEY_6 = 102;
      keyboardPackage.Keyboard.keyCode.NUMKEY1 = keyboardPackage.Keyboard.keyCode["NUMKEY 1"] = keyboardPackage.Keyboard.keyCode["NUMKEY-1"] = keyboardPackage.Keyboard.keyCode.NUMKEY_1 = 97;
      keyboardPackage.Keyboard.keyCode.NUMKEY2 = keyboardPackage.Keyboard.keyCode["NUMKEY 2"] = keyboardPackage.Keyboard.keyCode["NUMKEY-2"] = keyboardPackage.Keyboard.keyCode.NUMKEY_2 = 98;
      keyboardPackage.Keyboard.keyCode.NUMKEY3 = keyboardPackage.Keyboard.keyCode["NUMKEY 3"] = keyboardPackage.Keyboard.keyCode["NUMKEY-3"] = keyboardPackage.Keyboard.keyCode.NUMKEY_3 = 99;
      keyboardPackage.Keyboard.keyCode.NUMKEY0 = keyboardPackage.Keyboard.keyCode["NUMKEY 0"] = keyboardPackage.Keyboard.keyCode["NUMKEY-0"] = keyboardPackage.Keyboard.keyCode.NUMKEY_0 = 96;
      keyboardPackage.Keyboard.keyCode["NUMKEY."] = keyboardPackage.Keyboard.keyCode["NUMKEY ."] = keyboardPackage.Keyboard.keyCode["NUMKEY-."] = keyboardPackage.Keyboard.keyCode["NUMKEY_."] = 110;
      var code;
      for(var name in keyboardPackage.Keyboard.keyCode)
      {
         code = keyboardPackage.Keyboard.keyCode[name];
         if(keyboardPackage.Keyboard.keyCodeName[code] == undefined)
         {
            keyboardPackage.Keyboard.keyCodeName[code] = name;
         }
         else if(name.indexOf(" ") != -1 || name.length == 1)
         {
            if(keyboardPackage.Keyboard.keyCodeName[code].length == 1)
            {
               keyboardPackage.Keyboard.keyCodeName[code] = name + " (\"" + keyboardPackage.Keyboard.keyCodeName[code] + "\")";
            }
            else
            {
               keyboardPackage.Keyboard.keyCodeName[code] = name;
            }
         }
      }
   }
   static function getInstance()
   {
      if(keyboardPackage.Keyboard.myInstance == undefined)
      {
         keyboardPackage.Keyboard.myInstance = new keyboardPackage.Keyboard();
      }
      return keyboardPackage.Keyboard.myInstance;
   }
}
